#include "init.h"

void
swf_no_DisplayItem()
{
	rb_raise(rb_eRuntimeError, "already closed DisplayItem");
}

static void
swf_free_DisplayItem(p)
	t_DisplayItem *p;
{
	Debug("swf free DisplayItem");
	destroySWFDisplayItem(p->real);
}

VALUE
swf_DisplayItem_alloc(self, item)
	VALUE self;
	SWFDisplayItem item;
{
	t_DisplayItem *p;
	VALUE obj;
	
	obj = Data_Make_Struct(self, t_DisplayItem, 0, 0, p);
	p->real = item;
	return obj;
}

static VALUE
swf_DisplayItem_rotate(self, degrees)
	VALUE self, degrees;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_rotate(p->real, NUM2DBL(degrees));
	return Qnil;
}

static VALUE
swf_DisplayItem_rotate_to(self, degrees)
	VALUE self, degrees;
{
	t_DisplayItem *p;
	float f;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_rotateTo(p->real, NUM2DBL(degrees));
	return Qnil;
}

static VALUE
swf_DisplayItem_move(self, x, y)
	VALUE self, x, y;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_move(p->real, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_DisplayItem_move_to(self, x, y)
	VALUE self, x, y;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_moveTo(p->real, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_DisplayItem_scale(self, x_scale, y_scale)
	VALUE self, x_scale, y_scale;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_scale(p->real, NUM2DBL(x_scale), NUM2DBL(y_scale));
	return Qnil;
}

static VALUE
swf_DisplayItem_scale_to(self, x_scale, y_scale)
	VALUE self, x_scale, y_scale;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_scaleTo(p->real, NUM2DBL(x_scale), NUM2DBL(y_scale));
	return Qnil;
}

/*
void SWFDisplayItem_skewX(SWFDisplayItem item, float x);
void SWFDisplayItem_skewXTo(SWFDisplayItem item, float x);
void SWFDisplayItem_skewY(SWFDisplayItem item, float y);
void SWFDisplayItem_skewYTo(SWFDisplayItem item, float y);
*/
static VALUE
swf_DisplayItem_get_depth(self)
	VALUE self;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	return INT2FIX(SWFDisplayItem_getDepth(p->real));
}

static VALUE
swf_DisplayItem_set_depth(self, v)
	VALUE self, v;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_setDepth(p->real, NUM2INT(v));
	return v;
}

static VALUE
swf_DisplayItem_remove(self)
	VALUE self;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_remove(p->real);
	return Qnil;
}

static VALUE
swf_DisplayItem_set_name(self, v)
	VALUE self, v;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_setName(p->real, STR2CSTR(v));
	return Qnil;
}

static VALUE
swf_DisplayItem_set_ratio(self, v)
	VALUE self, v;
{
	t_DisplayItem *p;
	
	GetDisplayItem(self, p);
	SWFDisplayItem_setRatio(p->real, NUM2DBL(v));
	return Qnil;
}
/*
void SWFDisplayItem_setCXform(SWFDisplayItem item, SWFCXform cXform);
*/

static VALUE
swf_DisplayItem_add_color(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	t_DisplayItem *p;
	VALUE r, g, b, a;
	
	if (rb_scan_args(argc, argv, "31", &r, &g, &b, &a) == 3)
		a = INT2FIX(0);
	
	GetDisplayItem(self, p);
	SWFDisplayItem_setColorAdd(p->real,
		(byte)(NUM2CHR(r)),
		(byte)(NUM2CHR(g)),
		(byte)(NUM2CHR(b)),
		(byte)(NUM2CHR(a)));
	return Qnil;
}

static VALUE
swf_DisplayItem_mul_color(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	t_DisplayItem *p;
	VALUE r, g, b, a;
	
	if (rb_scan_args(argc, argv, "31", &r, &g, &b, &a) == 3)
		a = rb_float_new(1.0);
	
	GetDisplayItem(self, p);
	SWFDisplayItem_setColorMult(p->real,
		NUM2DBL(r),
		NUM2DBL(g),
		NUM2DBL(b),
		NUM2DBL(a));
	return Qnil;
}

void
swf_init_DisplayItem()
{
	cSwf_DisplayItem = rb_define_class_under(mSwf, "DisplayItem", rb_cObject);
	rb_define_method(cSwf_DisplayItem, "rotate", swf_DisplayItem_rotate, 1);
	rb_define_method(cSwf_DisplayItem, "rotate_to", swf_DisplayItem_rotate_to, 1);
	rb_define_method(cSwf_DisplayItem, "move", swf_DisplayItem_move, 2);
	rb_define_method(cSwf_DisplayItem, "move_to", swf_DisplayItem_move_to, 2);
	rb_define_method(cSwf_DisplayItem, "scale", swf_DisplayItem_scale, 2);
	rb_define_method(cSwf_DisplayItem, "scale_to", swf_DisplayItem_scale_to, 2);
	rb_define_method(cSwf_DisplayItem, "remove", swf_DisplayItem_remove, 0);
	rb_define_method(cSwf_DisplayItem, "name=", swf_DisplayItem_set_name, 1);
	rb_define_method(cSwf_DisplayItem, "ratio=", swf_DisplayItem_set_ratio, 1);
	rb_define_method(cSwf_DisplayItem, "add_color", swf_DisplayItem_add_color, -1);
	rb_define_method(cSwf_DisplayItem, "mul_color", swf_DisplayItem_mul_color, -1);
	DefineAttr(DisplayItem, depth)
}
