#include "init.h"

void
swf_no_movie()
{
	rb_raise(rb_eRuntimeError, "already closed movie");
}

static void
swf_free_movie(p)
	SWFMovie p;
{
	Debug("swf free movie");
	destroySWFMovie(p);
}

static VALUE
swf_movie_new(self)
	VALUE self;
{
	VALUE obj;
	SWFMovie p;
	
	p = newSWFMovie();
	obj = Data_Wrap_Struct(self, 0, swf_free_movie, p);
	return obj;
}
/*
SWFMovie newSWFMovieWithVersion(int version);
*/
static VALUE
swf_movie_get_rate(self)
	VALUE self;
{
	SWFMovie p;
	
	GetMovie(self, p);
	return rb_float_new(p->rate);
}

static VALUE
swf_movie_set_rate(self, v)
	VALUE self, v;
{
	SWFMovie p;
	
	GetMovie(self, p);
	SWFMovie_setRate(p, NUM2DBL(v));
	return v;
}

static VALUE
swf_movie_set_dimension(self, x, y)
	VALUE self, x, y;
{
	SWFMovie p;
	
	GetMovie(self, p);
	SWFMovie_setDimension(p, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_movie_set_frames(self, v)
	VALUE self, v;
{
	SWFMovie p;
	
	GetMovie(self, p);
	SWFMovie_setNumberOfFrames(p, NUM2INT(v));
	return v;
}

static VALUE
swf_movie_set_background(self, r, g, b)
	VALUE self, r, g, b;
{
	SWFMovie p;
	
	GetMovie(self, p);
	SWFMovie_setBackground(p, NUM2INT(r), NUM2INT(g), NUM2INT(b));
	return Qnil;
}

static VALUE
swf_movie_set_sound_stream(self, v)
	VALUE self, v;
{
	SWFMovie p;
	SWFSound p_sound;
	
	GetMovie(self, p);
	GetSound(v, p_sound);
	SWFMovie_setSoundStream(p, p_sound);
	return Qnil;
}

static VALUE
swf_movie_add(self, v)
	VALUE self, v;
{
	SWFMovie p;
	SWFBlock p_block;
	SWFDisplayItem item;
	
	GetMovie(self, p);
	GetBlock(v, p_block);
	RDATA(v)->dfree = NULL;
	item = SWFMovie_add(p, p_block);
	return swf_DisplayItem_alloc(cSwf_DisplayItem, item);
}

static VALUE
swf_movie_remove(self, v)
	VALUE self, v;
{
	SWFMovie p;
	t_DisplayItem *dip;
	
	GetMovie(self, p);
	GetDisplayItem(v, dip);
	SWFMovie_remove(p, dip->real);
	return Qnil;
}

static VALUE
swf_movie_next_frame(self)
	VALUE self;
{
	SWFMovie p;
	
	GetMovie(self, p);
	SWFMovie_nextFrame(p);
	return Qnil;
}

static VALUE
swf_movie_label_frame(self, v)
	VALUE self, v;
{
	SWFMovie p;
	
	GetMovie(self, p);
	SWFMovie_labelFrame(p, STR2CSTR(v));
	return Qnil;
}

static VALUE
swf_movie_output(self)
	VALUE self;
{
	SWFMovie p;
	
	GetMovie(self, p);
	SWFMovie_output(p, fileOutputMethod, stdout);
	return Qnil;
}

static VALUE
swf_movie_save(self, v)
	VALUE self, v;
{
	SWFMovie p;
	FILE* file;
	char* fname;
	
	GetMovie(self, p);
	fname = STR2CSTR(v);
	file = fopen(fname, "wb");
	if (file) {
		SWFMovie_output(p, fileOutputMethod, file);
		fclose(file);
	}
	return Qnil;
}

void
swf_init_movie()
{
	cSwf_movie = rb_define_class_under(mSwf, "Movie", rb_cObject);
	rb_define_singleton_method(cSwf_movie, "new", swf_movie_new, 0);
	DefineAttr(movie, rate)
	rb_define_method(cSwf_movie, "frames=", swf_movie_set_frames, 1);
	rb_define_method(cSwf_movie, "set_background", swf_movie_set_background, 3);
	rb_define_method(cSwf_movie, "set_dimension", swf_movie_set_dimension, 2);
	rb_define_method(cSwf_movie, "set_sound_stream", swf_movie_set_sound_stream, 1);
	rb_define_method(cSwf_movie, "add", swf_movie_add, 1);
	rb_define_method(cSwf_movie, "remove", swf_movie_remove, 1);
	rb_define_method(cSwf_movie, "next_frame", swf_movie_next_frame, 0);
	rb_define_method(cSwf_movie, "label_frame", swf_movie_label_frame, 1);
	rb_define_method(cSwf_movie, "output", swf_movie_output, 0);
	rb_define_method(cSwf_movie, "save", swf_movie_save, 1);
}
