#include "init.h"

void
swf_no_text()
{
	rb_raise(rb_eRuntimeError, "already closed text");
}

static void
swf_free_text(p)
	SWFText p;
{
	Debug("swf free text");
	destroySWFText(p);
}

static VALUE
swf_text_new(self)
	VALUE self;
{
	VALUE obj;
	SWFText p;
	
	p = newSWFText2();
	obj = Data_Wrap_Struct(self, 0, swf_free_text, p);
	return obj;
}

/*
SWFText newSWFText();
SWFText newSWFText2();
void destroySWFText(SWFBlock block);
*/

VALUE
swf_text_alloc(self, p)
	VALUE self;
	SWFText p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

//void SWFOutput_writeText(SWFOutput out, SWFText text);

static VALUE
swf_text_set_font(self, v)
	VALUE self, v;
{
	SWFText p;
	SWFBlock p_font;
	
	GetText(self, p);
	GetBlock(v, p_font);
	SWFText_setFont(p, p_font);
	return v;
}

static VALUE
swf_text_move_to(self, x, y)
	VALUE self, x, y;
{
	SWFText p;
	
	GetText(self, p);
	SWFText_moveTo(p, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_text_set_height(self, v)
	VALUE self, v;
{
	SWFText p;
	
	GetText(self, p);
	SWFText_setHeight(p, NUM2INT(v));
	return v;
}

static VALUE
swf_text_set_color(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	SWFText p;
	SWFFill p_fill;
	VALUE r, g, b, a;
	
	if (rb_scan_args(argc, argv, "31", &r, &g, &b, &a) == 3)
		a = INT2FIX(0xff);
	GetText(self, p);
	SWFText_setColor(p, 
		(byte)(NUM2CHR(r)),
		(byte)(NUM2CHR(g)),
		(byte)(NUM2CHR(b)),
		(byte)(NUM2CHR(a)));
	return Qnil;
}

static VALUE
swf_text_add_string(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	SWFText p;
	VALUE str, adv;
	char *string;
	int *advance;
	
	GetText(self, p);
	argc = rb_scan_args(argc, argv, "11", &str, &adv);
	string = STR2CSTR(str);
	if (argc > 1) {
		int i, len;
		
		Check_Type(adv, T_ARRAY);
		len = strlen(string);
		advance = (int *)malloc(sizeof(int) * len);
		for (i=0; i<len; ++i) {
			advance[i] = (i < RARRAY(adv)->len) ? NUM2INT(RARRAY(adv)->ptr[i]) : 0;
		}
	}
	else
		advance = NULL;
	
	SWFText_addString(p, string, advance);
	return Qnil;
}

static VALUE
swf_text_set_spacing(self, v)
	VALUE self, v;
{
	SWFText p;
	
	GetText(self, p);
	SWFText_setSpacing(p, NUM2DBL(v));
	return v;
}

static VALUE
swf_text_get_string_width(self, str)
	VALUE self, str;
{
	SWFText p;
	
	GetText(self, p);
	return INT2FIX(SWFText_getStringWidth(p, STR2CSTR(str)));
}

static VALUE
swf_text_get_ascent(self)
	VALUE self;
{
	SWFText p;
	
	GetText(self, p);
	return INT2FIX(SWFText_getAscent(p));
}

static VALUE
swf_text_get_descent(self)
	VALUE self;
{
	SWFText p;
	
	GetText(self, p);
	return INT2FIX(SWFText_getDescent(p));
}

static VALUE
swf_text_get_leading(self)
	VALUE self;
{
	SWFText p;
	
	GetText(self, p);
	return INT2FIX(SWFText_getLeading(p));
}

/*
void SWFText_resolveCodes(SWFText text);
*/

void
swf_init_text()
{
	cSwf_text = rb_define_class_under(mSwf, "Text", rb_cObject);
	rb_define_singleton_method(cSwf_text, "new", swf_text_new, 0);
	rb_define_method(cSwf_text, "font=", swf_text_set_font, 1);
	rb_define_method(cSwf_text, "move_to", swf_text_move_to, 2);
	rb_define_method(cSwf_text, "height=", swf_text_set_height, 1);
	rb_define_method(cSwf_text, "set_color", swf_text_set_color, -1);
	rb_define_method(cSwf_text, "add_string", swf_text_add_string, -1);
	rb_define_method(cSwf_text, "spacing=", swf_text_set_spacing, 1);
	rb_define_method(cSwf_text, "get_string_width", swf_text_get_string_width, 1);
	rb_define_method(cSwf_text, "ascent", swf_text_get_ascent, 0);
	rb_define_method(cSwf_text, "descent", swf_text_get_descent, 0);
	rb_define_method(cSwf_text, "leading", swf_text_get_leading, 0);
}
