
//#include <unistd.h>
#include <time.h>
#include <stdio.h>
#include <windows.h>
#include <winbase.h>

#include "../blocks/output.h"
#include "../blocks/action.h"
#include "compile.h"

extern FILE *yyin;
extern int yydebug;

int yyparse(void *b);

SWFAction compileSWFActionCode(char *script)
{
  SWFOutput output;
  int fds[2];
  FILE *out;
  Buffer b;

  //  yydebug = 1;

#ifdef WIN32
  _pipe(fds, 256, "O_BINARY");
#else
  pipe(fds);
#endif

  out = fdopen(fds[1], "w");
  fputs(script, out);
  fclose(out);

  yyin = fdopen(fds[0], "r");

  if(yyparse((void *)&b) != 0)
    return NULL;

  fclose(yyin);

  output = newSWFOutput();

  if(b)
  {
    SWFOutput_writeBuffer(output, b->buffer, bufferLength(b));
    destroyBuffer(b);
  }

  SWFOutput_writeUInt8(output, SWFACTION_END);

  return newSWFAction_fromOutput(output);
}
